/*****************************************************************************/
/*                        WiNRADiO G39DDC EXCELSIOR                          */
/*                                SDK DEMO                                   */
/*                 Simple edit box for fixed point numbers                   */
/*                        (C) Copyright RADIXON 2014                         */
/*****************************************************************************/

#include "u_floatedit.h"
#include <math.h>

TFloatEdit::TFloatEdit(wxWindow *Parent,wxWindowID Id,int64_t Value,int64_t MinValue,int64_t MaxValue,uint32_t DecNumCount,const wxPoint &Position,const wxSize &Size):TNumericEdit(Parent,Id,Value,MinValue,MaxValue,Position,Size)
{
    m_DecNumCount=DecNumCount;
    m_Divider=pow((double)10,(int)DecNumCount)+0.5;

    UpdateText();
}

TFloatEdit::~TFloatEdit(void)
{
}

wxString TFloatEdit::Format(int64_t Value)
{
 wxString s;

    s.sprintf(wxT("%.*f"),m_DecNumCount,(double)Value/m_Divider);

    return s;
}

bool TFloatEdit::Parse(const wxString &Str,int64_t *Value)
{ 
 double f;

    if(!Str.ToDouble(&f))
    {
        return false;
    }    

    if(f<0)
    {
        *Value=f*m_Divider-0.5;
    }
    else
    {
        *Value=f*m_Divider+0.5;
    }
    
    return true;
}