#ifndef __G39DDC_EXAMPLE_H__
#define __G39DDC_EXAMPLE_H__

#include "g39ddcapi.h"
#include <pulse/simple.h>

class TG39DDC:public IG39DDCDeviceCallback
{
public:
    bool LoadAPI(void);
    void UnloadAPI(void);

    bool Open(const char *DevicePath);

    inline bool OpenFirst(void)
    {
        //open the first available G39DDC receiver
        return Open(G39DDC_OPEN_FIRST);
    }

    inline bool OpenDemo(void)
    {
        //open demo G39DDC receiver
        return Open(G39DDC_OPEN_DEMO);
    }

    void Close(void);

    void StartStreaming(void);
    void StopStreaming(void);


    void OpenWaveOut(void);
    void CloseWaveOut(void);

    //methods of IG39DDCDeviceCallback callback interface
    void G39DDC_DDC1StreamCallback(IG39DDCDevice *Device,uint32_t Channel,const void *Buffer,uint32_t NumberOfSamples,uint32_t BitsPerSample);
    int G39DDC_DDC1PlaybackStreamCallback(IG39DDCDevice *Device,uint32_t Channel,void *Buffer,uint32_t NumberOfSamples,uint32_t BitsPerSample);
    void G39DDC_DDC2StreamCallback(IG39DDCDevice *Device,uint32_t Channel,const float *Buffer,uint32_t NumberOfSamples);
    void G39DDC_DDC2PreprocessedStreamCallback(IG39DDCDevice *Device,uint32_t Channel,const float *Buffer,uint32_t NumberOfSamples,float SlevelPeak,float SlevelRMS);
    void G39DDC_IFCallback(IG39DDCDevice *Device,const int16_t *Buffer,uint32_t NumberOfSamples,uint32_t CenterFrequency,uint16_t MaxADCAmplitude,uint32_t ADCSampleRate);
    int G39DDC_SweepingCallback(IG39DDCDevice *Device,const int16_t *Buffer,uint32_t NumberOfSamples,uint32_t CenterFrequency,uint64_t FrontEndFrequency);
    void G39DDC_AudioStreamCallback(IG39DDCDevice *Device,uint32_t Channel,uint32_t Type,const float *Buffer,uint32_t NumberOfSamples);
    int G39DDC_AudioPlaybackStreamCallback(IG39DDCDevice *Device,uint32_t Channel,float *Buffer,uint32_t NumberOfSamples);

    TG39DDC(void);
    ~TG39DDC(void);
private:
    IG39DDCDevice               *m_Device;
    void                        *m_API;
    G39DDCAPI_CREATE_INSTANCE   m_CreateInstance;
    pa_simple                   *m_PaSimple;
};

#endif
